Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision fa29d09342c79b886efacee4cfc3078be5f5a722)
+++ protocols/jabber/jabber.c	(revision 0da65d5fb37691ed4d31f7ab4058732f1440db6b)
@@ -33,5 +33,5 @@
 #include "jabber.h"
 
-static void jabber_acc_init( account_t *acc )
+static void jabber_init( account_t *acc )
 {
 	set_t *s;
@@ -59,11 +59,11 @@
 static void jabber_login( account_t *acc )
 {
-	struct gaim_connection *gc = new_gaim_conn( acc );
+	struct im_connection *ic = new_gaim_conn( acc );
 	struct jabber_data *jd = g_new0( struct jabber_data, 1 );
 	struct ns_srv_reply *srv = NULL;
 	char *connect_to, *s;
 	
-	jd->gc = gc;
-	gc->proto_data = jd;
+	jd->ic = ic;
+	ic->proto_data = jd;
 	
 	jd->username = g_strdup( acc->user );
@@ -72,6 +72,6 @@
 	if( jd->server == NULL )
 	{
-		hide_login_progress( gc, "Incomplete account name (format it like <username@jabberserver.name>)" );
-		signoff( gc );
+		hide_login_progress( ic, "Incomplete account name (format it like <username@jabberserver.name>)" );
+		signoff( ic );
 		return;
 	}
@@ -159,12 +159,12 @@
 		connect_to = jd->server;
 	
-	set_login_progress( gc, 0, "Connecting" );
+	set_login_progress( ic, 0, "Connecting" );
 	
 	if( set_getint( &acc->set, "port" ) < JABBER_PORT_MIN ||
 	    set_getint( &acc->set, "port" ) > JABBER_PORT_MAX )
 	{
-		serv_got_crap( gc, "Incorrect port number, must be in the %d-%d range",
+		serv_got_crap( ic, "Incorrect port number, must be in the %d-%d range",
 		               JABBER_PORT_MIN, JABBER_PORT_MAX );
-		signoff( gc );
+		signoff( ic );
 		return;
 	}
@@ -175,10 +175,10 @@
 	if( set_getbool( &acc->set, "ssl" ) )
 	{
-		jd->ssl = ssl_connect( connect_to, set_getint( &acc->set, "port" ), jabber_connected_ssl, gc );
+		jd->ssl = ssl_connect( connect_to, set_getint( &acc->set, "port" ), jabber_connected_ssl, ic );
 		jd->fd = jd->ssl ? ssl_getfd( jd->ssl ) : -1;
 	}
 	else
 	{
-		jd->fd = proxy_connect( connect_to, srv ? srv->port : set_getint( &acc->set, "port" ), jabber_connected_plain, gc );
+		jd->fd = proxy_connect( connect_to, srv ? srv->port : set_getint( &acc->set, "port" ), jabber_connected_plain, ic );
 	}
 	g_free( srv );
@@ -186,14 +186,14 @@
 	if( jd->fd == -1 )
 	{
-		hide_login_progress( gc, "Could not connect to server" );
-		signoff( gc );
-	}
-}
-
-static void jabber_close( struct gaim_connection *gc )
-{
-	struct jabber_data *jd = gc->proto_data;
-	
-	jabber_end_stream( gc );
+		hide_login_progress( ic, "Could not connect to server" );
+		signoff( ic );
+	}
+}
+
+static void jabber_logout( struct im_connection *ic )
+{
+	struct jabber_data *jd = ic->proto_data;
+	
+	jabber_end_stream( ic );
 	
 	if( jd->r_inpa >= 0 )
@@ -219,12 +219,12 @@
 }
 
-static int jabber_send_im( struct gaim_connection *gc, char *who, char *message, int len, int away )
-{
-	struct jabber_data *jd = gc->proto_data;
+static int jabber_send_im( struct im_connection *ic, char *who, char *message, int flags )
+{
+	struct jabber_data *jd = ic->proto_data;
 	struct jabber_buddy *bud;
 	struct xt_node *node;
 	int st;
 	
-	bud = jabber_buddy_by_jid( gc, who, 0 );
+	bud = jabber_buddy_by_jid( ic, who, 0 );
 	
 	node = xt_new_node( "body", message, NULL );
@@ -251,5 +251,5 @@
 	}
 	
-	st = jabber_write_packet( gc, node );
+	st = jabber_write_packet( ic, node );
 	xt_free_node( node );
 	
@@ -257,5 +257,5 @@
 }
 
-static GList *jabber_away_states( struct gaim_connection *gc )
+static GList *jabber_away_states( struct im_connection *ic )
 {
 	static GList *l = NULL;
@@ -269,11 +269,11 @@
 }
 
-static void jabber_get_info( struct gaim_connection *gc, char *who )
-{
-	struct jabber_data *jd = gc->proto_data;
+static void jabber_get_info( struct im_connection *ic, char *who )
+{
+	struct jabber_data *jd = ic->proto_data;
 	struct jabber_buddy *bud;
 	
 	if( strchr( who, '/' ) )
-		bud = jabber_buddy_by_jid( gc, who, 0 );
+		bud = jabber_buddy_by_jid( ic, who, 0 );
 	else
 	{
@@ -285,5 +285,5 @@
 	while( bud )
 	{
-		serv_got_crap( gc, "Buddy %s (%d) information:\nAway state: %s\nAway message: %s",
+		serv_got_crap( ic, "Buddy %s (%d) information:\nAway state: %s\nAway message: %s",
 		                   bud->full_jid, bud->priority,
 		                   bud->away_state ? bud->away_state->full_name : "(none)",
@@ -292,10 +292,10 @@
 	}
 	
-	jabber_get_vcard( gc, bud ? bud->full_jid : who );
-}
-
-static void jabber_set_away( struct gaim_connection *gc, char *state_txt, char *message )
-{
-	struct jabber_data *jd = gc->proto_data;
+	jabber_get_vcard( ic, bud ? bud->full_jid : who );
+}
+
+static void jabber_set_away( struct im_connection *ic, char *state_txt, char *message )
+{
+	struct jabber_data *jd = ic->proto_data;
 	struct jabber_away_state *state;
 	
@@ -306,35 +306,35 @@
 	jd->away_message = ( message && *message ) ? g_strdup( message ) : NULL;
 	
-	presence_send_update( gc );
-}
-
-static void jabber_add_buddy( struct gaim_connection *gc, char *who )
-{
-	if( jabber_add_to_roster( gc, who, NULL ) )
-		presence_send_request( gc, who, "subscribe" );
-}
-
-static void jabber_remove_buddy( struct gaim_connection *gc, char *who, char *group )
+	presence_send_update( ic );
+}
+
+static void jabber_add_buddy( struct im_connection *ic, char *who, char *group )
+{
+	if( jabber_add_to_roster( ic, who, NULL ) )
+		presence_send_request( ic, who, "subscribe" );
+}
+
+static void jabber_remove_buddy( struct im_connection *ic, char *who, char *group )
 {
 	/* We should always do this part. Clean up our administration a little bit. */
-	jabber_buddy_remove_bare( gc, who );
-	
-	if( jabber_remove_from_roster( gc, who ) )
-		presence_send_request( gc, who, "unsubscribe" );
-}
-
-static void jabber_keepalive( struct gaim_connection *gc )
+	jabber_buddy_remove_bare( ic, who );
+	
+	if( jabber_remove_from_roster( ic, who ) )
+		presence_send_request( ic, who, "unsubscribe" );
+}
+
+static void jabber_keepalive( struct im_connection *ic )
 {
 	/* Just any whitespace character is enough as a keepalive for XMPP sessions. */
-	jabber_write( gc, "\n", 1 );
+	jabber_write( ic, "\n", 1 );
 	
 	/* This runs the garbage collection every minute, which means every packet
 	   is in the cache for about a minute (which should be enough AFAIK). */
-	jabber_cache_clean( gc );
-}
-
-static int jabber_send_typing( struct gaim_connection *gc, char *who, int typing )
-{
-	struct jabber_data *jd = gc->proto_data;
+	jabber_cache_clean( ic );
+}
+
+static int jabber_send_typing( struct im_connection *ic, char *who, int typing )
+{
+	struct jabber_data *jd = ic->proto_data;
 	struct jabber_buddy *bud;
 	
@@ -342,5 +342,5 @@
 	jd->flags |= JFLAG_WANT_TYPING;
 	
-	if( ( bud = jabber_buddy_by_jid( gc, who, 0 ) ) == NULL )
+	if( ( bud = jabber_buddy_by_jid( ic, who, 0 ) ) == NULL )
 	{
 		/* Sending typing notifications to unknown buddies is
@@ -369,5 +369,5 @@
 		node = jabber_make_packet( "message", "chat", bud->full_jid, node );
 		
-		st = jabber_write_packet( gc, node );
+		st = jabber_write_packet( ic, node );
 		xt_free_node( node );
 		
@@ -378,5 +378,5 @@
 }
 
-void jabber_init()
+void jabber_initmodule()
 {
 	struct prpl *ret = g_new0( struct prpl, 1 );
@@ -384,6 +384,6 @@
 	ret->name = "jabber";
 	ret->login = jabber_login;
-	ret->acc_init = jabber_acc_init;
-	ret->close = jabber_close;
+	ret->init = jabber_init;
+	ret->logout = jabber_logout;
 	ret->send_im = jabber_send_im;
 	ret->away_states = jabber_away_states;
Index: protocols/jabber/jabber.h
===================================================================
--- protocols/jabber/jabber.h	(revision fa29d09342c79b886efacee4cfc3078be5f5a722)
+++ protocols/jabber/jabber.h	(revision 0da65d5fb37691ed4d31f7ab4058732f1440db6b)
@@ -58,5 +58,5 @@
 struct jabber_data
 {
-	struct gaim_connection *gc;
+	struct im_connection *ic;
 	
 	int fd;
@@ -87,5 +87,5 @@
 };
 
-typedef xt_status (*jabber_cache_event) ( struct gaim_connection *gc, struct xt_node *node, struct xt_node *orig );
+typedef xt_status (*jabber_cache_event) ( struct im_connection *ic, struct xt_node *node, struct xt_node *orig );
 
 struct jabber_cache_entry
@@ -137,10 +137,10 @@
 /* iq.c */
 xt_status jabber_pkt_iq( struct xt_node *node, gpointer data );
-int jabber_init_iq_auth( struct gaim_connection *gc );
-xt_status jabber_pkt_bind_sess( struct gaim_connection *gc, struct xt_node *node, struct xt_node *orig );
-int jabber_get_roster( struct gaim_connection *gc );
-int jabber_get_vcard( struct gaim_connection *gc, char *bare_jid );
-int jabber_add_to_roster( struct gaim_connection *gc, char *handle, char *name );
-int jabber_remove_from_roster( struct gaim_connection *gc, char *handle );
+int jabber_init_iq_auth( struct im_connection *ic );
+xt_status jabber_pkt_bind_sess( struct im_connection *ic, struct xt_node *node, struct xt_node *orig );
+int jabber_get_roster( struct im_connection *ic );
+int jabber_get_vcard( struct im_connection *ic, char *bare_jid );
+int jabber_add_to_roster( struct im_connection *ic, char *handle, char *name );
+int jabber_remove_from_roster( struct im_connection *ic, char *handle );
 
 /* message.c */
@@ -149,6 +149,6 @@
 /* presence.c */
 xt_status jabber_pkt_presence( struct xt_node *node, gpointer data );
-int presence_send_update( struct gaim_connection *gc );
-int presence_send_request( struct gaim_connection *gc, char *handle, char *request );
+int presence_send_update( struct im_connection *ic );
+int presence_send_request( struct im_connection *ic, char *handle, char *request );
 
 /* jabber_util.c */
@@ -157,11 +157,11 @@
 struct xt_node *jabber_make_packet( char *name, char *type, char *to, struct xt_node *children );
 struct xt_node *jabber_make_error_packet( struct xt_node *orig, char *err_cond, char *err_type );
-void jabber_cache_add( struct gaim_connection *gc, struct xt_node *node, jabber_cache_event func );
-struct xt_node *jabber_cache_get( struct gaim_connection *gc, char *id );
+void jabber_cache_add( struct im_connection *ic, struct xt_node *node, jabber_cache_event func );
+struct xt_node *jabber_cache_get( struct im_connection *ic, char *id );
 void jabber_cache_entry_free( gpointer entry );
-void jabber_cache_clean( struct gaim_connection *gc );
+void jabber_cache_clean( struct im_connection *ic );
 const struct jabber_away_state *jabber_away_state_by_code( char *code );
 const struct jabber_away_state *jabber_away_state_by_name( char *name );
-void jabber_buddy_ask( struct gaim_connection *gc, char *handle );
+void jabber_buddy_ask( struct im_connection *ic, char *handle );
 char *jabber_normalize( char *orig );
 
@@ -172,18 +172,18 @@
 } get_buddy_flags_t;
 
-struct jabber_buddy *jabber_buddy_add( struct gaim_connection *gc, char *full_jid );
-struct jabber_buddy *jabber_buddy_by_jid( struct gaim_connection *gc, char *jid, get_buddy_flags_t flags );
-int jabber_buddy_remove( struct gaim_connection *gc, char *full_jid );
-int jabber_buddy_remove_bare( struct gaim_connection *gc, char *bare_jid );
+struct jabber_buddy *jabber_buddy_add( struct im_connection *ic, char *full_jid );
+struct jabber_buddy *jabber_buddy_by_jid( struct im_connection *ic, char *jid, get_buddy_flags_t flags );
+int jabber_buddy_remove( struct im_connection *ic, char *full_jid );
+int jabber_buddy_remove_bare( struct im_connection *ic, char *bare_jid );
 
 extern const struct jabber_away_state jabber_away_state_list[];
 
 /* io.c */
-int jabber_write_packet( struct gaim_connection *gc, struct xt_node *node );
-int jabber_write( struct gaim_connection *gc, char *buf, int len );
+int jabber_write_packet( struct im_connection *ic, struct xt_node *node );
+int jabber_write( struct im_connection *ic, char *buf, int len );
 gboolean jabber_connected_plain( gpointer data, gint source, b_input_condition cond );
 gboolean jabber_connected_ssl( gpointer data, void *source, b_input_condition cond );
-gboolean jabber_start_stream( struct gaim_connection *gc );
-void jabber_end_stream( struct gaim_connection *gc );
+gboolean jabber_start_stream( struct im_connection *ic );
+void jabber_end_stream( struct im_connection *ic );
 
 /* sasl.c */
@@ -191,5 +191,5 @@
 xt_status sasl_pkt_challenge( struct xt_node *node, gpointer data );
 xt_status sasl_pkt_result( struct xt_node *node, gpointer data );
-gboolean sasl_supported( struct gaim_connection *gc );
+gboolean sasl_supported( struct im_connection *ic );
 
 #endif
Index: protocols/jabber/jabber_util.c
===================================================================
--- protocols/jabber/jabber_util.c	(revision fa29d09342c79b886efacee4cfc3078be5f5a722)
+++ protocols/jabber/jabber_util.c	(revision 0da65d5fb37691ed4d31f7ab4058732f1440db6b)
@@ -42,5 +42,5 @@
 	/* Only run this stuff if the account is online ATM,
 	   and if the setting seems to be acceptable. */
-	if( acc->gc )
+	if( acc->ic )
 	{
 		/* Although set_eval functions usually are very nice and
@@ -58,5 +58,5 @@
 		/* (Yes, sorry, I prefer the hack. :-P) */
 		
-		presence_send_update( acc->gc );
+		presence_send_update( acc->ic );
 	}
 	
@@ -130,7 +130,7 @@
    them when you receive the response. Use this BEFORE sending the packet so
    it'll get a new id= tag, and do NOT free() the packet after writing it! */
-void jabber_cache_add( struct gaim_connection *gc, struct xt_node *node, jabber_cache_event func )
-{
-	struct jabber_data *jd = gc->proto_data;
+void jabber_cache_add( struct im_connection *ic, struct xt_node *node, jabber_cache_event func )
+{
+	struct jabber_data *jd = ic->proto_data;
 	char *id = g_strdup_printf( "%s%05x", JABBER_CACHED_ID, ( next_id++ ) & 0xfffff );
 	struct jabber_cache_entry *entry = g_new0( struct jabber_cache_entry, 1 );
@@ -159,7 +159,7 @@
    node should be available in the cache for at least a minute (assuming the
    function is indeed called every minute). */
-void jabber_cache_clean( struct gaim_connection *gc )
-{
-	struct jabber_data *jd = gc->proto_data;
+void jabber_cache_clean( struct im_connection *ic )
+{
+	struct jabber_data *jd = ic->proto_data;
 	
 	g_hash_table_foreach_remove( jd->node_cache, jabber_cache_clean_entry, NULL );
@@ -214,5 +214,5 @@
 struct jabber_buddy_ask_data
 {
-	struct gaim_connection *gc;
+	struct im_connection *ic;
 	char *handle;
 	char *realname;
@@ -221,8 +221,8 @@
 static void jabber_buddy_ask_yes( gpointer w, struct jabber_buddy_ask_data *bla )
 {
-	presence_send_request( bla->gc, bla->handle, "subscribed" );
-	
-	if( find_buddy( bla->gc, bla->handle ) == NULL )
-		show_got_added( bla->gc, bla->handle, NULL );
+	presence_send_request( bla->ic, bla->handle, "subscribed" );
+	
+	if( find_buddy( bla->ic, bla->handle ) == NULL )
+		show_got_added( bla->ic, bla->handle, NULL );
 	
 	g_free( bla->handle );
@@ -232,5 +232,5 @@
 static void jabber_buddy_ask_no( gpointer w, struct jabber_buddy_ask_data *bla )
 {
-	presence_send_request( bla->gc, bla->handle, "subscribed" );
+	presence_send_request( bla->ic, bla->handle, "subscribed" );
 	
 	g_free( bla->handle );
@@ -238,14 +238,14 @@
 }
 
-void jabber_buddy_ask( struct gaim_connection *gc, char *handle )
+void jabber_buddy_ask( struct im_connection *ic, char *handle )
 {
 	struct jabber_buddy_ask_data *bla = g_new0( struct jabber_buddy_ask_data, 1 );
 	char *buf;
 	
-	bla->gc = gc;
+	bla->ic = ic;
 	bla->handle = g_strdup( handle );
 	
 	buf = g_strdup_printf( "The user %s wants to add you to his/her buddy list.", handle );
-	do_ask_dialog( gc, buf, bla, jabber_buddy_ask_yes, jabber_buddy_ask_no );
+	do_ask_dialog( ic, buf, bla, jabber_buddy_ask_yes, jabber_buddy_ask_no );
 	g_free( buf );
 }
@@ -271,7 +271,7 @@
    to deal with that properly. Set their ->resource property to NULL. Do *NOT*
    allow to mix this stuff, though... */
-struct jabber_buddy *jabber_buddy_add( struct gaim_connection *gc, char *full_jid_ )
-{
-	struct jabber_data *jd = gc->proto_data;
+struct jabber_buddy *jabber_buddy_add( struct im_connection *ic, char *full_jid_ )
+{
+	struct jabber_data *jd = ic->proto_data;
 	struct jabber_buddy *bud, *new, *bi;
 	char *s, *full_jid;
@@ -343,7 +343,7 @@
    asked for a bare JID, it uses the "resource_select" setting to see which
    resource to pick. */
-struct jabber_buddy *jabber_buddy_by_jid( struct gaim_connection *gc, char *jid_, get_buddy_flags_t flags )
-{
-	struct jabber_data *jd = gc->proto_data;
+struct jabber_buddy *jabber_buddy_by_jid( struct im_connection *ic, char *jid_, get_buddy_flags_t flags )
+{
+	struct jabber_data *jd = ic->proto_data;
 	struct jabber_buddy *bud;
 	char *s, *jid;
@@ -371,8 +371,8 @@
 		}
 		
-		if( bud == NULL && ( flags & GET_BUDDY_CREAT ) && find_buddy( gc, jid ) )
+		if( bud == NULL && ( flags & GET_BUDDY_CREAT ) && find_buddy( ic, jid ) )
 		{
 			*s = '/';
-			bud = jabber_buddy_add( gc, jid );
+			bud = jabber_buddy_add( ic, jid );
 		}
 		
@@ -391,6 +391,6 @@
 		if( bud == NULL )
 			/* No match. Create it now? */
-			return ( ( flags & GET_BUDDY_CREAT ) && find_buddy( gc, jid_ ) ) ?
-			           jabber_buddy_add( gc, jid_ ) : NULL;
+			return ( ( flags & GET_BUDDY_CREAT ) && find_buddy( ic, jid_ ) ) ?
+			           jabber_buddy_add( ic, jid_ ) : NULL;
 		else if( bud->resource && ( flags & GET_BUDDY_EXACT ) )
 			/* We want an exact match, so in thise case there shouldn't be a /resource. */
@@ -409,5 +409,5 @@
 		}
 		
-		if( ( set = set_getstr( &gc->acc->set, "resource_select" ) ) == NULL )
+		if( ( set = set_getstr( &ic->acc->set, "resource_select" ) ) == NULL )
 			return NULL;
 		else if( strcmp( set, "activity" ) == 0 )
@@ -421,7 +421,7 @@
    off-line (because (s)he can still be online from a different location.
    XXX: See above, we should accept bare JIDs too... */
-int jabber_buddy_remove( struct gaim_connection *gc, char *full_jid_ )
-{
-	struct jabber_data *jd = gc->proto_data;
+int jabber_buddy_remove( struct im_connection *ic, char *full_jid_ )
+{
+	struct jabber_data *jd = ic->proto_data;
 	struct jabber_buddy *bud, *prev, *bi;
 	char *s, *full_jid;
@@ -495,7 +495,7 @@
    specified bare JID. Use this when removing someone from the contact
    list, for example. */
-int jabber_buddy_remove_bare( struct gaim_connection *gc, char *bare_jid_ )
-{
-	struct jabber_data *jd = gc->proto_data;
+int jabber_buddy_remove_bare( struct im_connection *ic, char *bare_jid_ )
+{
+	struct jabber_data *jd = ic->proto_data;
 	struct jabber_buddy *bud, *next;
 	char *bare_jid;
Index: protocols/jabber/message.c
===================================================================
--- protocols/jabber/message.c	(revision fa29d09342c79b886efacee4cfc3078be5f5a722)
+++ protocols/jabber/message.c	(revision 0da65d5fb37691ed4d31f7ab4058732f1440db6b)
@@ -26,5 +26,5 @@
 xt_status jabber_pkt_message( struct xt_node *node, gpointer data )
 {
-	struct gaim_connection *gc = data;
+	struct im_connection *ic = data;
 	char *from = xt_find_attr( node, "from" );
 	char *type = xt_find_attr( node, "type" );
@@ -47,5 +47,5 @@
 		if( ( s = strchr( from, '/' ) ) )
 		{
-			if( ( bud = jabber_buddy_by_jid( gc, from, GET_BUDDY_EXACT ) ) )
+			if( ( bud = jabber_buddy_by_jid( ic, from, GET_BUDDY_EXACT ) ) )
 				bud->last_act = time( NULL );
 			else
@@ -76,5 +76,5 @@
 		
 		if( fullmsg->len > 0 )
-			serv_got_im( gc, bud ? bud->bare_jid : from, fullmsg->str, 0, 0, fullmsg->len );
+			serv_got_im( ic, bud ? bud->bare_jid : from, fullmsg->str, 0, 0, fullmsg->len );
 		
 		g_string_free( fullmsg, TRUE );
@@ -84,5 +84,5 @@
 		{
 			bud->flags |= JBFLAG_DOES_XEP85;
-			serv_got_typing( gc, bud ? bud->bare_jid : from, 0, 1 );
+			serv_got_typing( ic, bud ? bud->bare_jid : from, 0, 1 );
 		}
 		/* No need to send a "stopped typing" signal when there's a message. */
@@ -90,10 +90,10 @@
 		{
 			bud->flags |= JBFLAG_DOES_XEP85;
-			serv_got_typing( gc, bud ? bud->bare_jid : from, 0, 0 );
+			serv_got_typing( ic, bud ? bud->bare_jid : from, 0, 0 );
 		}
 		else if( xt_find_node( node->children, "paused" ) )
 		{
 			bud->flags |= JBFLAG_DOES_XEP85;
-			serv_got_typing( gc, bud ? bud->bare_jid : from, 0, 2 );
+			serv_got_typing( ic, bud ? bud->bare_jid : from, 0, 2 );
 		}
 		
Index: protocols/jabber/presence.c
===================================================================
--- protocols/jabber/presence.c	(revision fa29d09342c79b886efacee4cfc3078be5f5a722)
+++ protocols/jabber/presence.c	(revision 0da65d5fb37691ed4d31f7ab4058732f1440db6b)
@@ -26,5 +26,5 @@
 xt_status jabber_pkt_presence( struct xt_node *node, gpointer data )
 {
-	struct gaim_connection *gc = data;
+	struct im_connection *ic = data;
 	char *from = xt_find_attr( node, "from" );
 	char *type = xt_find_attr( node, "type" );	/* NULL should mean the person is online. */
@@ -38,8 +38,8 @@
 	if( type == NULL )
 	{
-		if( !( bud = jabber_buddy_by_jid( gc, from, GET_BUDDY_EXACT | GET_BUDDY_CREAT ) ) )
+		if( !( bud = jabber_buddy_by_jid( ic, from, GET_BUDDY_EXACT | GET_BUDDY_CREAT ) ) )
 		{
-			if( set_getbool( &gc->irc->set, "debug" ) )
-				serv_got_crap( gc, "WARNING: Could not handle presence information from JID: %s", from );
+			if( set_getbool( &ic->irc->set, "debug" ) )
+				serv_got_crap( ic, "WARNING: Could not handle presence information from JID: %s", from );
 			return XT_HANDLED;
 		}
@@ -66,17 +66,17 @@
 			bud->priority = 0;
 		
-		serv_got_update( gc, bud->bare_jid, 1, 0, 0, 0,
+		serv_got_update( ic, bud->bare_jid, 1, 0, 0, 0,
 		                 bud->away_state ? UC_UNAVAILABLE : 0, 0 );
 	}
 	else if( strcmp( type, "unavailable" ) == 0 )
 	{
-		if( jabber_buddy_by_jid( gc, from, GET_BUDDY_EXACT ) == NULL )
+		if( jabber_buddy_by_jid( ic, from, GET_BUDDY_EXACT ) == NULL )
 		{
-			if( set_getbool( &gc->irc->set, "debug" ) )
-				serv_got_crap( gc, "WARNING: Received presence information from unknown JID: %s", from );
+			if( set_getbool( &ic->irc->set, "debug" ) )
+				serv_got_crap( ic, "WARNING: Received presence information from unknown JID: %s", from );
 			return XT_HANDLED;
 		}
 		
-		jabber_buddy_remove( gc, from );
+		jabber_buddy_remove( ic, from );
 		
 		if( ( s = strchr( from, '/' ) ) )
@@ -86,6 +86,6 @@
 			/* Only count this as offline if there's no other resource
 			   available anymore. */
-			if( jabber_buddy_by_jid( gc, from, 0 ) == NULL )
-				serv_got_update( gc, from, 0, 0, 0, 0, 0, 0 );
+			if( jabber_buddy_by_jid( ic, from, 0 ) == NULL )
+				serv_got_update( ic, from, 0, 0, 0, 0, 0, 0 );
 			
 			*s = '/';
@@ -93,15 +93,15 @@
 		else
 		{
-			serv_got_update( gc, from, 0, 0, 0, 0, 0, 0 );
+			serv_got_update( ic, from, 0, 0, 0, 0, 0, 0 );
 		}
 	}
 	else if( strcmp( type, "subscribe" ) == 0 )
 	{
-		jabber_buddy_ask( gc, from );
+		jabber_buddy_ask( ic, from );
 	}
 	else if( strcmp( type, "subscribed" ) == 0 )
 	{
 		/* Not sure about this one, actually... */
-		serv_got_crap( gc, "%s just accepted your authorization request", from );
+		serv_got_crap( ic, "%s just accepted your authorization request", from );
 	}
 	else if( strcmp( type, "unsubscribe" ) == 0 || strcmp( type, "unsubscribed" ) == 0 )
@@ -131,7 +131,7 @@
 /* Whenever presence information is updated, call this function to inform the
    server. */
-int presence_send_update( struct gaim_connection *gc )
+int presence_send_update( struct im_connection *ic )
 {
-	struct jabber_data *jd = gc->proto_data;
+	struct jabber_data *jd = ic->proto_data;
 	struct xt_node *node;
 	char *show = jd->away_state->code;
@@ -140,5 +140,5 @@
 	
 	node = jabber_make_packet( "presence", NULL, NULL, NULL );
-	xt_add_child( node, xt_new_node( "priority", set_getstr( &gc->acc->set, "priority" ), NULL ) );
+	xt_add_child( node, xt_new_node( "priority", set_getstr( &ic->acc->set, "priority" ), NULL ) );
 	if( show && *show )
 		xt_add_child( node, xt_new_node( "show", show, NULL ) );
@@ -146,5 +146,5 @@
 		xt_add_child( node, xt_new_node( "status", status, NULL ) );
 	
-	st = jabber_write_packet( gc, node );
+	st = jabber_write_packet( ic, node );
 	
 	xt_free_node( node );
@@ -153,5 +153,5 @@
 
 /* Send a subscribe/unsubscribe request to a buddy. */
-int presence_send_request( struct gaim_connection *gc, char *handle, char *request )
+int presence_send_request( struct im_connection *ic, char *handle, char *request )
 {
 	struct xt_node *node;
@@ -162,5 +162,5 @@
 	xt_add_attr( node, "type", request );
 	
-	st = jabber_write_packet( gc, node );
+	st = jabber_write_packet( ic, node );
 	
 	xt_free_node( node );
Index: protocols/jabber/sasl.c
===================================================================
--- protocols/jabber/sasl.c	(revision fa29d09342c79b886efacee4cfc3078be5f5a722)
+++ protocols/jabber/sasl.c	(revision 0da65d5fb37691ed4d31f7ab4058732f1440db6b)
@@ -27,16 +27,16 @@
 xt_status sasl_pkt_mechanisms( struct xt_node *node, gpointer data )
 {
-	struct gaim_connection *gc = data;
-	struct jabber_data *jd = gc->proto_data;
+	struct im_connection *ic = data;
+	struct jabber_data *jd = ic->proto_data;
 	struct xt_node *c, *reply;
 	char *s;
 	int sup_plain = 0, sup_digest = 0;
 	
-	if( !sasl_supported( gc ) )
+	if( !sasl_supported( ic ) )
 	{
 		/* Should abort this now, since we should already be doing
 		   IQ authentication. Strange things happen when you try
 		   to do both... */
-		serv_got_crap( gc, "XMPP 1.0 non-compliant server seems to support SASL, please report this as a BitlBee bug!" );
+		serv_got_crap( ic, "XMPP 1.0 non-compliant server seems to support SASL, please report this as a BitlBee bug!" );
 		return XT_HANDLED;
 	}
@@ -45,5 +45,5 @@
 	if( !s || strcmp( s, XMLNS_SASL ) != 0 )
 	{
-		signoff( gc );
+		signoff( ic );
 		return XT_ABORT;
 	}
@@ -62,6 +62,6 @@
 	if( !sup_plain && !sup_digest )
 	{
-		hide_login_progress( gc, "No known SASL authentication schemes supported" );
-		signoff( gc );
+		hide_login_progress( ic, "No known SASL authentication schemes supported" );
+		signoff( ic );
 		return XT_ABORT;
 	}
@@ -83,9 +83,9 @@
 		
 		/* With SASL PLAIN in XMPP, the text should be b64(\0user\0pass) */
-		len = strlen( jd->username ) + strlen( gc->acc->pass ) + 2;
+		len = strlen( jd->username ) + strlen( ic->acc->pass ) + 2;
 		s = g_malloc( len + 1 );
 		s[0] = 0;
 		strcpy( s + 1, jd->username );
-		strcpy( s + 2 + strlen( jd->username ), gc->acc->pass );
+		strcpy( s + 2 + strlen( jd->username ), ic->acc->pass );
 		reply->text = base64_encode( s, len );
 		reply->text_len = strlen( reply->text );
@@ -93,5 +93,5 @@
 	}
 	
-	if( !jabber_write_packet( gc, reply ) )
+	if( !jabber_write_packet( ic, reply ) )
 	{
 		xt_free_node( reply );
@@ -181,6 +181,6 @@
 xt_status sasl_pkt_challenge( struct xt_node *node, gpointer data )
 {
-	struct gaim_connection *gc = data;
-	struct jabber_data *jd = gc->proto_data;
+	struct im_connection *ic = data;
+	struct jabber_data *jd = ic->proto_data;
 	struct xt_node *reply = NULL;
 	char *nonce = NULL, *realm = NULL, *cnonce = NULL, cnonce_bin[30];
@@ -222,5 +222,5 @@
 		   I decided to call it H. */
 		md5_init( &H );
-		s = g_strdup_printf( "%s:%s:%s", jd->username, realm, gc->acc->pass );
+		s = g_strdup_printf( "%s:%s:%s", jd->username, realm, ic->acc->pass );
 		md5_append( &H, (unsigned char *) s, strlen( s ) );
 		g_free( s );
@@ -272,5 +272,5 @@
 	xt_add_attr( reply, "xmlns", XMLNS_SASL );
 	
-	if( !jabber_write_packet( gc, reply ) )
+	if( !jabber_write_packet( ic, reply ) )
 		goto silent_error;
 	
@@ -279,6 +279,6 @@
 
 error:
-	hide_login_progress( gc, "Incorrect SASL challenge received" );
-	signoff( gc );
+	hide_login_progress( ic, "Incorrect SASL challenge received" );
+	signoff( ic );
 
 silent_error:
@@ -296,6 +296,6 @@
 xt_status sasl_pkt_result( struct xt_node *node, gpointer data )
 {
-	struct gaim_connection *gc = data;
-	struct jabber_data *jd = gc->proto_data;
+	struct im_connection *ic = data;
+	struct jabber_data *jd = ic->proto_data;
 	char *s;
 	
@@ -303,5 +303,5 @@
 	if( !s || strcmp( s, XMLNS_SASL ) != 0 )
 	{
-		signoff( gc );
+		signoff( ic );
 		return XT_ABORT;
 	}
@@ -309,11 +309,11 @@
 	if( strcmp( node->name, "success" ) == 0 )
 	{
-		set_login_progress( gc, 1, "Authentication finished" );
+		set_login_progress( ic, 1, "Authentication finished" );
 		jd->flags |= JFLAG_AUTHENTICATED | JFLAG_STREAM_RESTART;
 	}
 	else if( strcmp( node->name, "failure" ) == 0 )
 	{
-		hide_login_progress( gc, "Authentication failure" );
-		signoff( gc );
+		hide_login_progress( ic, "Authentication failure" );
+		signoff( ic );
 		return XT_ABORT;
 	}
@@ -325,7 +325,7 @@
    It's done by checking if the <stream:stream> from the server has a
    version attribute. I don't know if this is the right way though... */
-gboolean sasl_supported( struct gaim_connection *gc )
-{
-	struct jabber_data *jd = gc->proto_data;
+gboolean sasl_supported( struct im_connection *ic )
+{
+	struct jabber_data *jd = ic->proto_data;
 	
 	return ( (void*) ( jd->xt && jd->xt->root && xt_find_attr( jd->xt->root, "version" ) ) ) != NULL;
